#include <stdio.h>
#include "eth.h"
#include "ns8390.h"

void read_eth_addr( NS8390 *ns8390, HWA_ADDR_P hwa );
int ns8390_reset ( NIF *ne_nif );
int ns8390_send( NIF *ne_nif, HWA_ADDR_P eth_dest, HWA_ADDR_P eth_src, UINT16 eth_type, 
                  int data_length, UINT8 *eth_data );
void ns8390_start( NIF *ne_nif );


void EnableCache( void )
{
  __asm__(" nop\n"
          "move.l  #0x80000000,%d0\n"
	      "dc.l	0x4e7b0002		| movec d0,cacr\n"
	      "nop ");
}


int main()
{
  int index;

  ETH_ADDR myaddr;
  ETH_ADDR destaddr = { 0x00, 0xC0, 0xDF, 0x44, 0x35, 0x95 };
  NS8390 *ns8390;
  NIF ne_nif;
  UINT8 ethdata[1024];


  ns8390 = (NS8390 *)0x40000300;
  ne_nif.nic = (void *)ns8390;

  EnableCache();
  printf("About to find the ethernet address of the NE2000 card\n");
  read_eth_addr( ns8390, myaddr );

  printf("Ethernet address is : ");
  for (index = 0; index < 6; index++)
    printf(" %X ",myaddr[index]);
  printf("\n");

  printf("Going for a Reset...\n");
  ns8390_reset(&ne_nif);
  printf("Done it...\n");

  ns8390_start(&ne_nif);

  printf("Trying to send a dodgy packet\n");
  ns8390_send( &ne_nif, destaddr, myaddr, FRAME_IP, 100, ethdata );
  printf("Done it...\n");

  printf("sending lots of packets!\n");
  for (index = 0; index < 10000; index++)
    ns8390_send( &ne_nif, destaddr, myaddr, FRAME_IP, 100, ethdata );
  printf("Done it...\n");
  


  
  return 0;
}
